"use strict";
exports.__esModule = true;
exports.init = exports.invoke = void 0;
var index_1 = require("./index");
// User shold implement the invoke method
function invoke(txid) {
    var funcName = (0, index_1.FuncName)(txid);
    var paras = (0, index_1.Parameters)(txid);
    (0, index_1.smlog)("invoke function name is " + funcName);
    var i = 0;
    var argsNum = paras.length;
    for (i = 0; i < argsNum; i++) {
        (0, index_1.smlog)(" the arg is " + String.UTF8.decode(paras[i], true));
    }
    if (funcName == "initMarble") {
        return initMarble(txid, paras);
    }
    else if (funcName == "getMarble") {
        var value = getMarble(txid, paras);
        return value;
    }
    else if (funcName == "delMarble") {
        return delMarble(txid, paras);
    }
    else if (funcName == "init2Marble") {
        return init2Marble(txid, paras);
    }
    else if (funcName == "get3Marble") {
        var value3 = get3Marble(txid, paras);
        return value3;
    }
    else if (funcName == "rwMarble") {
        var valueRw = rwMarble(txid, paras);
        return valueRw;
    }
    else if (funcName == "getRange") {
        var valueRange = getRange(txid, paras);
        return valueRange;
    }
    else if (funcName == "putData") {
        var valueRange = putData(txid, paras);
        return valueRange;
    }
    else if (funcName == "insert") {
        var valueRange = insert(txid, paras);
        return valueRange;
    }
    (0, index_1.smlog)("the function is not known:" + funcName);
    return (0, index_1.MakeErrRes)("The function name is not known:" + funcName);
}
exports.invoke = invoke;
// User shold implement the init method
function init(txid) {
    var funcName = (0, index_1.FuncName)(txid);
    var paras = (0, index_1.Parameters)(txid);
    (0, index_1.smlog)("init function name is " + funcName);
    var i = 0;
    var argsNum = paras.length;
    for (i = 0; i < argsNum; i++) {
        (0, index_1.smlog)(" the arg is " + String.UTF8.decode(paras[i], true));
    }
    if (funcName == "init") {
        return initContract(txid, paras);
    }
    (0, index_1.smlog)("the function is not known:" + funcName);
    return (0, index_1.MakeErrRes)("The function name is not known:" + funcName);
}
exports.init = init;
function putData(txid, args) {
    if (args.length < 2) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var i = 0;
    for (i = 0; i < 1000; i++) {
        var key = (0, index_1.ArrayBuffer2Str)(args[0]) + i.toString();
        var value = (0, index_1.ArrayBuffer2Str)(args[1]) + i.toString();
        (0, index_1.PutKV)(txid, key, (0, index_1.Str2ArrayBuffer)(value));
        (0, index_1.smlog)("the key is " + key + " the value is " + value);
    }
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)("putdata success"));
}
function getRange(txid, args) {
    (0, index_1.smlog)("wasm enter getRange");
    if (args.length < 2) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var beginKey = (0, index_1.ArrayBuffer2Str)(args[0]);
    var endKey = (0, index_1.ArrayBuffer2Str)(args[1]);
    (0, index_1.smlog)("before iterator new, the beginkey is " + beginKey + " the end key is " + endKey);
    var itor = (0, index_1.IteratorNew)(txid, beginKey, endKey);
    if (itor == 0) {
        (0, index_1.smlog)("IteratorNew fail, itor=" + itor.toString() + "ret=" + itor.toString());
        return (0, index_1.MakeErrRes)("IteratorNew fail, itor=" + itor.toString() + "ret=" + itor.toString());
    }
    var strRes = "";
    while ((0, index_1.IteNext)(itor)) {
        strRes += (0, index_1.IteKey)(itor);
        strRes += " ";
        var v = (0, index_1.IteValue)(itor);
        strRes += (0, index_1.ArrayBuffer2Str)(v);
        strRes += ";";
    }
    var ret = 0;
    ret = (0, index_1.IteratorFree)(itor);
    if (ret != 0) {
        (0, index_1.smlog)("IteratorFree fail, itor=" + itor.toString() + "ret=" + ret.toString());
        return (0, index_1.MakeErrRes)("IteratorFree fail, itor=" + itor.toString() + "ret=" + ret.toString());
    }
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)(strRes));
}
function initContract(txid, args) {
    if (args.length < 2) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var key = (0, index_1.ArrayBuffer2Str)(args[0]);
    var value = args[1];
    (0, index_1.smlog)("the txid is " + txid + " the key is " + key + " the value is " + (0, index_1.ArrayBuffer2Str)(value));
    (0, index_1.PutKV)(txid, key, value);
    (0, index_1.smlog)("init finished.");
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)("init success."));
}
function initMarble(txid, args) {
    if (args.length < 2) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var key = (0, index_1.ArrayBuffer2Str)(args[0]);
    var value = args[1];
    (0, index_1.smlog)("the txid is " + txid + " the key is " + key + " the value is " + (0, index_1.ArrayBuffer2Str)(value));
    var getValue = (0, index_1.GetKV)(txid, key);
    (0, index_1.smlog)("the get value is " + (0, index_1.ArrayBuffer2Str)(getValue));
    (0, index_1.PutKV)(txid, key, value);
    (0, index_1.smlog)("initMarble finished.");
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)("initMarble finished."));
}
function init2Marble(txid, args) {
    if (args.length < 4) {
        (0, index_1.smlog)("the args number is small than 4 :" + args.length.toString());
        return (0, index_1.MakeErrRes)("the args number is small than 4 :" + args.length.toString());
    }
    var key1 = (0, index_1.ArrayBuffer2Str)(args[0]);
    var value1 = args[1];
    (0, index_1.PutKV)(txid, key1, value1);
    var key2 = (0, index_1.ArrayBuffer2Str)(args[2]);
    var value2 = args[3];
    (0, index_1.PutKV)(txid, key2, value2);
    (0, index_1.smlog)("init2Marble finished");
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)("init2Marble finished."));
}
function getMarble(txid, args) {
    if (args.length < 1) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        //todo the empty ArrayBuffer
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var key = (0, index_1.ArrayBuffer2Str)(args[0]);
    var value = (0, index_1.GetKV)(txid, key);
    (0, index_1.smlog)("getMarble finished, the value is :" + (0, index_1.ArrayBuffer2Str)(value));
    return (0, index_1.MakeSuccessRes)(value);
}
function rwMarble(txid, args) {
    if (args.length < 3) {
        (0, index_1.smlog)("in rwMarble, the args number is not correct:" + args.length.toString());
        return (0, index_1.MakeErrRes)("in rwMarble, the args number is not correct:" + args.length.toString());
    }
    var key = (0, index_1.ArrayBuffer2Str)(args[0]);
    var valueRead = (0, index_1.GetKV)(txid, key);
    (0, index_1.smlog)("the value read is " + (0, index_1.ArrayBuffer2Str)(valueRead));
    var key2 = (0, index_1.ArrayBuffer2Str)(args[1]);
    var value2 = args[2];
    (0, index_1.PutKV)(txid, key2, value2);
    return (0, index_1.MakeSuccessRes)(valueRead);
}
function get3Marble(txid, args) {
    if (args.length < 3) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        //todo the empty ArrayBuffer
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var key = (0, index_1.ArrayBuffer2Str)(args[0]);
    var value = (0, index_1.GetKV)(txid, key);
    (0, index_1.smlog)("getMarble, the value1 is :" + (0, index_1.ArrayBuffer2Str)(value));
    var key2 = (0, index_1.ArrayBuffer2Str)(args[1]);
    var value2 = (0, index_1.GetKV)(txid, key2);
    (0, index_1.smlog)("getMarble, the value2 is :" + (0, index_1.ArrayBuffer2Str)(value2));
    var key3 = (0, index_1.ArrayBuffer2Str)(args[2]);
    var value3 = (0, index_1.GetKV)(txid, key3);
    (0, index_1.smlog)("getMarble, the value3 is :" + (0, index_1.ArrayBuffer2Str)(value3));
    return (0, index_1.MakeSuccessRes)(value);
}
function delMarble(txid, args) {
    if (args.length < 1) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        //todo the empty ArrayBuffer
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var key = (0, index_1.ArrayBuffer2Str)(args[0]);
    (0, index_1.DelKV)(txid, key);
    var resStr = "delMarble finished, the key is :" + key;
    (0, index_1.smlog)(resStr);
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)(resStr));
}
function insert(txid, args) {
    if (args.length < 2) {
        (0, index_1.smlog)("the args number is not correct: " + args.length.toString());
        return (0, index_1.MakeErrRes)("the args number is not correct: " + args.length.toString());
    }
    var i = 0;
    for (i = 0; i < 1000; i++) {
        var key = (0, index_1.ArrayBuffer2Str)(args[0]) + i.toString();
        var value = (0, index_1.ArrayBuffer2Str)(args[1]) + i.toString();
        (0, index_1.PutKV)(txid, key, (0, index_1.Str2ArrayBuffer)(value));
        (0, index_1.smlog)("the key is " + key + " the value is " + value);
    }
    return (0, index_1.MakeSuccessRes)((0, index_1.Str2ArrayBuffer)("putdata success"));
}
